diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
new file mode 100644
index 000000000..266bdd7fd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
@@ -0,0 +1,350 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public abstract class WorldFeatureSpoonerTreeProcedural
+    extends WorldFeatureSpoonerTree {
+    protected static double TRUNK_THICKNESS = 1.0;
+    protected static double BRANCH_DENSITY = 1.0;
+    protected static double FOLIAGE_DENSITY = 1.0;
+    protected static double TRUNK_HEIGHT = 0.7;
+    protected static double HEIGHT = 25;
+
+    protected double trunkHeight = 0.0D;
+    protected double trunkRadius = 0.0D;
+    protected double branchDensity = 0.0D;
+    protected double branchSlope = 0.0D;
+    protected double[] foliageShape = null;
+    protected List<int[]> foliageCoords = null;
+
+    public WorldFeatureSpoonerTreeProcedural(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    protected void crossSection(int[] center, double radius, int dirAxis, int id, int data, World world) {
+        int rad = MathHelper.floor_double(radius + 0.618);
+        int secidx1 = (dirAxis + 1) % 3;
+        int secidx2 = (dirAxis + 2) % 3;
+        int[] coord = new int[3];
+        for (int off1 = -rad; off1 < rad + 1; off1++) {
+            for (int off2 = -rad; off2 < rad + 1; off2++) {
+                double thisDist = Math.sqrt(Math.pow(Math.abs(off1) + 0.5, 2) + Math.pow(Math.abs(off2) + 0.5, 2));
+                if (thisDist > radius) {
+                    continue;
+                }
+                int pri = center[dirAxis];
+                int sec1 = center[secidx1] + off1;
+                int sec2 = center[secidx2] + off2;
+                coord[dirAxis] = pri;
+                coord[secidx1] = sec1;
+                coord[secidx2] = sec2;
+                assignValue(coord[0], coord[1], coord[2], id, data, world);
+            }
+        }
+    }
+
+    /*
+     * Take y and return a radius for the location of the foliage cluster.
+     *
+     * If no foliage cluster is to be created, return null
+     */
+    protected Double shapeFunc(int y) {
+        if (random.nextDouble() < 100 / Math.pow(this.height, 2) && y < this.trunkHeight) {
+            return this.height * 0.12;
+        }
+        return null;
+    }
+
+    /* Generate a round cluster of foliage at the location center.
+     *
+     * The shape of the cluster is defined by the array foliageShape.
+     */
+    protected void foliageCluster(int[] center, World world) {
+        double[] levelRadius = this.foliageShape;
+        int x = center[0];
+        int y = center[1];
+        int z = center[2];
+        for (double i : levelRadius) {
+            crossSection(new int[] { x, y, z }, i, 1, leavesId, leavesData, world);
+            y++;
+        }
+    }
+
+    /* Create a tapered cylinder.
+     *
+     * start and end are the beginning and ending coordinates of form [x,y,z].
+     * startSize and endSize are the beginning and ending radius.
+     */
+    protected void taperedLimb(int[] start, int[] end, double startSize, double endSize, World world) {
+        // delta is the coordinate vector for the difference between
+        // start and end.
+        int[] delta = new int[] { end[0] - start[0], end[1] - start[1], end[2] - start[2] };
+        int maxDist = Math.max(delta[0], Math.max(delta[1], delta[2]));
+        if (maxDist == 0) {
+            return;
+        }
+        int primidx = 0;
+        for (int i = 0; i < 3; i++) {
+            if (delta[i] == maxDist) {
+                primidx = i;
+                break;
+            }
+        }
+        // secidx1 and secidx2 are the remaining indices out of [0,1,2].
+        int secidx1 = (primidx - 1) % 3;
+        if (secidx1 < 0) secidx1 += 3;
+        int secidx2 = (1 + primidx) % 3;
+        // primSign is the digit 1 or -1 depending on whether the limb is headed
+        // along the positive or negative primidx axis.
+        int primSign = delta[primidx] / Math.abs(delta[primidx]);
+        // secdelta1 and ...2 are the amount the associated values change
+        // for every step along the prime axis.
+        int secdelta1 = delta[secidx1];
+        float secfac1 = ((float)secdelta1) / delta[primidx];
+        int secdelta2 = delta[secidx2];
+        float secfac2 = ((float)secdelta2) / delta[primidx];
+        // Initialize coord
+        int[] coord = new int[3];
+        // Loop through each cross-section along the primary axis,
+        // from start to end.
+        int endOffset = delta[primidx] + primSign;
+        for (int primOffset = 0; primOffset < endOffset; primOffset += primSign) {
+            int primLoc = start[primidx] + primOffset;
+            int secloc1 = (int)(start[secidx1] + primOffset * secfac1);
+            int secloc2 = (int)(start[secidx2] + primOffset * secfac2);
+            coord[primidx] = primLoc;
+            coord[secidx1] = secloc1;
+            coord[secidx2] = secloc2;
+            int primDist = Math.abs(delta[primidx]);
+            double radius = endSize + (startSize - endSize) * Math.abs(delta[primidx] - primOffset) / primDist;
+            crossSection(coord, radius, primidx, trunkId, trunkData, world);
+        }
+    }
+
+    @Override
+    protected void makeFoliage(World world) {
+        List<int[]> foliageCoords = this.foliageCoords;
+
+        for (int[] coord: foliageCoords) {
+            foliageCluster(coord, world);
+        }
+        for (int[] coord: foliageCoords) {
+            assignValue(coord[0], coord[1], coord[2], trunkId, trunkData, world);
+        }
+    }
+
+    /* Generate the branches.
+     */
+    protected void makeBranches(World world) {
+        int[] treePosition = this.pos;
+        int height = this.height;
+        int topY = treePosition[1] + (int)(this.trunkHeight + 0.5);
+        double endRad = this.trunkRadius * (1 - this.trunkHeight / height);
+        if (endRad < 1.0) {
+            endRad = 1.0;
+        }
+        for (int[] coord: foliageCoords) {
+            double dist = Math.sqrt(Math.pow(coord[0] - treePosition[0], 2) + Math.pow(coord[2] - treePosition[2], 2));
+            int yDist = coord[1] - treePosition[1];
+            double value = (this.branchDensity * 220 * height) / (Math.pow(yDist + dist, 3));
+            if (value < random.nextDouble()) {
+                continue;
+            }
+
+            int posY = coord[1];
+            double slope = this.branchSlope + (0.5 - random.nextDouble()) * 0.16;
+            double branchY;
+            double baseSize;
+            if (coord[1] - dist * slope > topY) {
+                double threshold = 1.0 / height;
+                if (Math.random() < threshold) {
+                    continue;
+                }
+                branchY = topY;
+                baseSize = endRad;
+            } else {
+                branchY = posY - dist * slope;
+                baseSize = (endRad + (this.trunkRadius - endRad) * (topY - branchY) / this.trunkHeight);
+            }
+            double startSize = (baseSize * (1 + random.nextDouble()) * 0.618 * Math.pow(dist / height, 0.618));
+            double rndr = Math.sqrt(random.nextDouble()) * baseSize * 0.618;
+            double rndang = Math.random() * 2 * Math.PI;
+            int rndx = (int)(rndr * Math.sin(rndang) + 0.5);
+            int rndz = (int)(rndr * Math.cos(rndang) + 0.5);
+            int[] startCoord = new int[] { treePosition[0] + rndx, (int) branchY, treePosition[2] + rndz };
+            if (startSize < 1.0) {
+                startSize = 1.0;
+            }
+            double endSize = 1.0;
+            taperedLimb(startCoord, coord, startSize, endSize, world);
+        }
+    }
+
+    /* Generate the roots.
+     *
+     * rootBases = [[x, z, baseRadius], ...] and is the list of locations
+     * the roots can originate from, and the size of that location.
+     */
+    void makeRoots(List<double[]> rootBases, World world) {
+        int[] treePosition = this.pos;
+        int height = this.height;
+        for (int[] coord: this.foliageCoords) {
+            // First, set the threshold for randomly selecting this
+            // coordinate for root creation.
+            double dist = Math.sqrt(Math.pow(coord[0] - treePosition[0], 2) + Math.pow(coord[2] - treePosition[2], 2));
+            int yDist = coord[1] - treePosition[1];
+            double value = (this.branchDensity * 220 * height) / Math.pow(yDist + dist, 3);
+            // Randomly skip roots, based on the above threshold
+            if (value < random.nextDouble()) {
+                continue;
+            }
+            // initialize the internal variables from a selection of
+            // starting locations.
+            double[] rootBase = rootBases.get(random.nextInt(rootBases.size()));
+            int rootX = (int) rootBase[0];
+            int rootZ = (int) rootBase[1];
+            double rootBaseRadius = rootBase[2];
+            // Offset the root origin location by a random amount
+            // (radially) from the starting location.
+            double rndr = Math.sqrt(random.nextDouble()) * rootBaseRadius * 0.618;
+            double rndang = random.nextDouble() * 2 * Math.PI;
+            int rndx = (int)(rndr * Math.sin(rndang) + 0.5);
+            int rndz = (int)(rndr * Math.cos(rndang) + 0.5);
+            int rndy = (int)(random.nextDouble() * rootBaseRadius * 0.5);
+            int[] startCoord = new int[] { rootX + rndx, treePosition[1] + rndy, rootZ + rndz };
+            // offset is the distance from the root base to the root tip
+            int[] offset = new int[] { startCoord[0] - coord[0], startCoord[1] - coord[1], startCoord[2] - coord[2] };
+            // If this is a mangrove tree, make the roots longer.
+            if (this instanceof WorldFeatureSpoonerTreeMangrove) {
+                offset = new int[] { (int)(offset[0] * 1.618 - 1.5), (int)(offset[1] * 1.618 - 1.5), (int)(offset[2] * 1.618 - 1.5) };
+            }
+            int[] endCoord = new int[] { startCoord[0] + offset[0], startCoord[1] + offset[1], startCoord[2] + offset[2] };
+            double rootStartSize = rootBaseRadius * 0.618 * Math.abs(offset[1]) / (height * 0.618);
+            if (rootStartSize < 1.0) {
+                rootStartSize = 1.0;
+            }
+            double endSize = 1.0;
+            // TODO: accommodate tostone and hanging behaviours
+            if (false) {
+
+            } else {
+                taperedLimb(startCoord, endCoord, rootStartSize, endSize, world);
+            }
+        }
+    }
+
+    @Override
+    protected void makeTrunk(World world) {
+        int height = this.height;
+        double trunkHeight = this.trunkHeight;
+        double trunkRadius = this.trunkRadius;
+        int[] treePosition = this.pos;
+        int startY = treePosition[1];
+        int midY = treePosition[1] + (int)(trunkHeight * 0.382);
+        int topY = treePosition[1] + (int)(trunkHeight + 0.5);
+        // In this method, x and z are the position of the trunk.
+        int x = treePosition[0];
+        int z = treePosition[2];
+        double midRad = trunkRadius * 0.8;
+        double endRad = trunkRadius * (1 - trunkHeight / height);
+        if (endRad < 1.0) {
+            endRad = 1.0;
+        }
+        if (midRad < endRad) {
+            midRad = endRad;
+        }
+        double startRad;
+        List<double[]> rootBases;
+        // Make the root buttresses, if indicated
+        // TODO: root buttresses
+        if (/* root buttresses or */ this instanceof WorldFeatureSpoonerTreeMangrove) {
+            // The start radius of the trunk should be a little smaller if we
+            // are using root buttresses.
+            startRad = trunkRadius * 0.8;
+            // rootbases is used later in makeRoots(...) as
+            // starting locations for the roots.
+            rootBases = new ArrayList<>();
+            rootBases.add(new double[] { x, z, startRad });
+            double buttressRadius = trunkRadius * 0.382;
+            // posRadius is how far the root buttresses should be offset
+            // from the trunk.
+            double posRadius = trunkRadius;
+            // In mangroves, the root buttresses are much more extended.
+            if (this instanceof WorldFeatureSpoonerTreeMangrove) {
+                posRadius = posRadius * 2.618;
+            }
+            int numOfButtresses = (int)(Math.sqrt(trunkRadius) + 3.5);
+            for (int i = 0; i < numOfButtresses; i++) {
+                double rndang = random.nextDouble() * 2 * Math.PI;
+                double thisPosRadius = posRadius * (0.9 + random.nextDouble() * 0.2);
+                // thisX and thisZ are the X and Z position for the base of
+                // the root buttress.
+                int thisX = x + (int)(thisPosRadius * Math.sin(rndang));
+                int thisZ = z + (int)(thisPosRadius * Math.cos(rndang));
+                // thisButtressRadius is the radius of the buttress.
+                // Currently, root buttresses do not taper.
+                double thisButtressRadius = buttressRadius * (0.618 * random.nextDouble());
+                if (thisButtressRadius < 1.0) {
+                    thisButtressRadius = 1.0;
+                }
+                // Make the root buttress.
+                taperedLimb(new int[] { thisX, startY, thisZ }, new int[] { x, midY, z }, thisButtressRadius, thisButtressRadius, world);
+                // Adds this root buttress as a possible location at which roots can spawn.
+                rootBases.add(new double[] { thisX, thisZ, thisButtressRadius });
+            }
+        } else {
+            // If root buttresses are turned off, set the trunk radius
+            // to normal size.
+            startRad = trunkRadius;
+            rootBases = new ArrayList<>();
+            rootBases.add(new double[] { x, z, startRad });
+        }
+        // Make the lower and upper sections of the trunk.
+        taperedLimb(new int[] { x, startY, z }, new int[] { x, midY, z }, startRad, midRad, world);
+        taperedLimb(new int[] { x, midY, z }, new int[] { x, topY, z }, midRad, endRad, world);
+        // Make the branches
+        makeBranches(world);
+        // Make the roots, if indicated
+        // TODO: roots
+        if (false) {
+
+        }
+    }
+
+    @Override
+    protected void prepare(World world) {
+        // Primarily sets up the foliage cluster locations
+        this.trunkRadius = Math.sqrt(this.height * TRUNK_THICKNESS);
+        if (this.trunkRadius < 1) {
+            this.trunkRadius = 1;
+        }
+        this.trunkHeight = this.height * 0.618;
+        this.branchDensity = BRANCH_DENSITY / FOLIAGE_DENSITY;
+        List<int[]> foliageCoords = new ArrayList<>();
+        int yStart = this.pos[1];
+        int yEnd = this.pos[1] + this.height;
+        int numOfClustersPerY = (int)(1.5 + Math.pow(FOLIAGE_DENSITY * this.height / 19.0, 2));
+        if (numOfClustersPerY < 1) {
+            numOfClustersPerY = 1;
+        }
+        for (int y = yEnd; y > yStart; y--) {
+            for (int i = 0; i < numOfClustersPerY; i++) {
+                Double shapefac = shapeFunc(y - yStart);
+                if (shapefac == null) {
+                    continue;
+                }
+                double r = (Math.sqrt(random.nextDouble()) + 0.328) * shapefac;
+
+                double theta = random.nextDouble() * 2 * Math.PI;
+                int x = (int)(r * Math.sin(theta)) + this.pos[0];
+                int z = (int)(r * Math.cos(theta)) + this.pos[2];
+                foliageCoords.add(new int[] { x, y, z });
+            }
+        }
+        this.foliageCoords = foliageCoords;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java
new file mode 100644
index 000000000..9710b49ba
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeRainforest
+    extends WorldFeatureSpoonerTreeProcedural {
+    public WorldFeatureSpoonerTreeRainforest(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void prepare(World world) {
+        this.foliageShape = new double[] { 3.4, 2.6 };
+        super.prepare(world);
+        this.branchSlope = 1.0;
+        this.trunkRadius = this.trunkRadius * 0.382;
+        this.trunkHeight = this.height * 0.9;
+    }
+
+    @Override
+    protected Double shapeFunc(int y) {
+        if (y < this.height * 0.8) {
+            if (HEIGHT < this.height) {
+                Double twigs = super.shapeFunc(y);
+                if (twigs != null && random.nextDouble() < 0.05) {
+                    return twigs;
+                }
+            }
+            return null;
+        } else {
+            double width = this.height * 0.382;
+            double topDist = (this.height - y) / (this.height * 0.2);
+            return width * (0.618 + topDist) * (0.618 + random.nextDouble()) * 0.382;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java
new file mode 100644
index 000000000..4b30d4ece
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeRound
+    extends WorldFeatureSpoonerTreeProcedural {
+
+    public WorldFeatureSpoonerTreeRound(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void prepare(World world) {
+        super.prepare(world);
+        this.branchSlope = 0.382;
+        this.foliageShape = new double[] { 2, 3, 3, 2.5, 1.6 };
+        this.trunkRadius = this.trunkRadius * 0.8;
+        this.trunkHeight = TRUNK_HEIGHT * this.height;
+    }
+
+    @Override
+    protected Double shapeFunc(int y) {
+        Double twigs = super.shapeFunc(y);
+        if (twigs != null) {
+            return twigs;
+        }
+        if (y < this.height * (0.282 + 0.1 * Math.sqrt(random.nextDouble()))) {
+            return null;
+        }
+        double radius = this.height / 2.0;
+        double adj = this.height / 2.0 - y;
+        double dist;
+        if (adj == 0) {
+            dist = radius;
+        } else if (Math.abs(adj) >= radius) {
+            dist = 0;
+        } else {
+            dist = Math.sqrt(Math.pow(radius, 2) - Math.pow(adj, 2));
+        }
+        dist = dist * 0.618;
+        return dist;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java
new file mode 100644
index 000000000..afe7b203e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java
@@ -0,0 +1,22 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public abstract class WorldFeatureSpoonerTreeStick
+    extends WorldFeatureSpoonerTree {
+    public WorldFeatureSpoonerTreeStick(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void makeTrunk(World world) {
+        int x = this.pos[0];
+        int y = this.pos[1];
+        int z = this.pos[2];
+
+        for (int i = 0; i < this.height; i++) {
+            assignValue(x, y, z, this.trunkId, this.trunkData, world);
+            y++;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
index 104992762..72d01acde 100644
--- a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
@@ -1,5 +1,6 @@
 package net.minecraft.server.net.handler;
 
+import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.Map;
@@ -14,6 +15,7 @@ import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.NetworkManager;
@@ -904,7 +906,12 @@ public class NetServerHandler extends NetHandler
     				playerEntity.world.markBlockNeedsUpdate(tileEntity.x, tileEntity.y, tileEntity.z);
     			}
     		}
-    	}
+    	} else if ("BTA|WandMonster".equals(packet.channel)) {
+            if (playerEntity.getHeldItem() != null && playerEntity.getHeldItem().getItem() == Item.wandMonsterSpawner){
+                String id = new String(packet.data, StandardCharsets.UTF_8);
+                playerEntity.getHeldItem().getData().putString("monster", id);
+            }
+        }
     }
 
     @Override
